## linkchecker 1.3.7.1

=== Makefile ===
# This Makefile is only used by developers.
VERSION=$(shell ./setup.py --version)
PACKAGE=linkchecker
NAME=$(shell ./setup.py --name)
PACKAGEDIR=/home/groups/l/li/$(PACKAGE)
HTMLDIR=shell1.sourceforge.net:$(PACKAGEDIR)/htdocs
FTPDIR=shell1.sourceforge.net:/home/groups/ftp/pub/$(PACKAGE)
#HOST=treasure.calvinsplayground.de
HOST=linkchecker.sourceforge.net
#LCOPTS=-ocolored -Ftext -Fhtml -Fgml -Fsql -Fcsv -Fxml -R -t0 -v -s
LCOPTS=-ocolored -Ftext -Fhtml -Fgml -Fsql -Fcsv -Fxml -R -t0 -v -s
OFFLINETESTS = test_base test_misc test_file test_frames
ONLINETESTS = test_mail test_http test_https test_news test_ftp
DESTDIR=/.

.PHONY: all
all:
	@echo "Read the file INSTALL to see how to build and install"

.PHONY: clean
clean:
	-./setup.py clean --all # ignore errors of this command
	$(MAKE) -C po clean
	find . -name '*.py[co]' | xargs rm -f

.PHONY: distclean
distclean: clean cleandeb
	rm -rf dist build # just to be sure clean also the build dir
	rm -f VERSION _$(PACKAGE)_configdata.py MANIFEST Packages.gz
	# clean aborted dist builds and -out files
	rm -f $(PACKAGE)-*
	rm -rf linkcheckssl/ssl.so

.PHONY: localbuild
localbuild: config
	./setup.py build
	cp -f build/lib.linux-i686-2.0/linkcheckssl/ssl.so linkcheckssl

.PHONY: cleandeb
cleandeb:
	rm -rf debian/$(PACKAGE) debian/tmp
	rm -f debian/*.debhelper debian/{files,substvars}
	rm -f configure-stamp build-stamp

.PHONY: config
config:
	./setup.py config -lcrypto

# no rpm package; too much trouble, cannot test
.PHONY: dist
dist:	locale config
	./setup.py sdist --formats=gztar,zip # bdist_rpm
	# extra run without SSL compilation
	./setup.py bdist_wininst --bitmap="guruguru.bmp"

deb:
	# cleandeb because distutils choke on dangling symlinks
	# (linkchecker.1 -> undocumented.1)
	$(MAKE) cleandeb
	fakeroot debian/rules binary
	env CVSROOT=:pserver:anonymous@cvs.linkchecker.sourceforge.net:/cvsroot/linkchecker cvs-buildpackage -Mlinkchecker -W/home/calvin/projects/cvs-build -sgpg -pgpg -k959C340F -rfakeroot 

.PHONY: files
files:	locale
	env http_proxy="" ./$(PACKAGE) $(LCOPTS) -i$(HOST) http://$(HOST)/

VERSION:
	echo $(VERSION) > VERSION

.PHONY: upload
upload: distclean dist files VERSION
	scp debian/changelog $(HTMLDIR)/changes.txt
	scp README $(HTMLDIR)/readme.txt
	scp linkchecker-out.* $(HTMLDIR)
	scp VERSION $(HTMLDIR)/raw/
	scp dist/* $(FTPDIR)/
	scp dist/* $(HTMLDIR)/
	ssh -C -t shell1.sourceforge.net "cd $(PACKAGEDIR) && make"

.PHONY: test
test:
	python test/regrtest.py $(OFFLINETESTS)

.PHONY: onlinetest
onlinetest:
	python test/regrtest.py $(ONLINETESTS)

.PHONY: locale
locale:
	$(MAKE) -C po

.PHONY: timeouttest
timeouttest:
	./$(PACKAGE) -DDD --timeout=2 mailto:calvin@cs.uni-sb.de

=== po/Makefile ===
# we copied the scripts in Tools/i18n of the Python 2.0 distribution
I18NTOOLS=.
PYTHON=python2.0
GETTEXT=$(PYTHON) $(I18NTOOLS)/pygettext.py
MSGFMT=$(PYTHON) $(I18NTOOLS)/msgfmt.py
#MSGFMT=msgfmt
MSGMERGE=msgmerge
SOURCES=\
../linkcheck/Config.py \
../linkcheck/FileUrlData.py \
../linkcheck/FtpUrlData.py \
../linkcheck/GopherUrlData.py \
../linkcheck/HostCheckingUrlData.py \
../linkcheck/HttpUrlData.py \
../linkcheck/HttpsUrlData.py \
../linkcheck/JavascriptUrlData.py \
../linkcheck/Logging.py \
../linkcheck/MailtoUrlData.py \
../linkcheck/NntpUrlData.py \
../linkcheck/TelnetUrlData.py \
../linkcheck/Threader.py \
../linkcheck/UrlData.py \
../linkcheck/__init__.py \
../linkcheck/lc_cgi.py \
../linkchecker
TARGETS=de.mo fr.mo
PACKAGE=linkcheck

all:
	$(MAKE) $(TARGETS)

%.po:	.time.pot
	$(MSGMERGE) $@ $(PACKAGE).pot -o $@

.time.pot:
	rm -f $(PACKAGE).pot
	$(GETTEXT) --default-domain=$(PACKAGE) --no-location $(SOURCES)
	touch .time.pot

# for GNU msgfmt use -o flag:
#$(MSGFMT) $< -o $@ && mkdir -p ../locale/$*/LC_MESSAGES && mv $@ ../locale/$*/LC_MESSAGES/$(PACKAGE).mo
%.mo:	%.po
	$(MSGFMT) $< && mkdir -p ../locale/$*/LC_MESSAGES && mv $@ ../locale/$*/LC_MESSAGES/$(PACKAGE).mo

clean:
	rm -f .time.pot
	rm -rf ../locale

=== debian/changelog ===
linkchecker (1.3.7.1) unstable; urgency=low

  * NMU to depend on python (2.1). Closes: #118254.

 -- Matthias Klose <doko@debian.org>  Fri,  7 Dec 2001 09:33:22 +0100

linkchecker (1.3.7) unstable; urgency=low

  * fix typo in DNS/Base.py Windows Registry handling
  * minor code cleanups
  * add missing split* import for proxy handling (Closes: #115931)

 -- Bastian Kleineidam <calvin@debian.org>  Wed, 17 Oct 2001 14:40:34 +0200

linkchecker (1.3.6) unstable; urgency=low

  * fix typo in Copyright blurb
  * implemented Proxy Authentication (untested)
  * Opera Bookmark files (opera.adr) support, they are parsed
    automatically. This support only works for local file links
    (ie. file:///home/joe/.opera/opera.adr)
  * support for TCP socket timeouts with --timeout (untested)
  * replace string module functions with Python 2.x string methods
  * use TCP for DNS MX mailhost lookup as default, not UDP as it seems
    to hang forever (dont know why). This should fix bug #106393, but
    only time and tests will tell.
  * updated DNS.init_dns_config with Windows-specific functions from
    pydns.sf.net (tested only under Win2000)

 -- Bastian Kleineidam <calvin@debian.org>  Wed, 22 Aug 2001 19:34:13 +0200

linkchecker (1.3.5) unstable; urgency=low

  * add traceback import into testsuite
  * fix HTTPS support by using correct import statement and
    calling HTTPS.connect()
  * standards version 3.5.6 (no changes)
  * updated german translation

 -- Bastian Kleineidam <calvin@debian.org>  Wed,  1 Aug 2001 22:32:55 +0200

linkchecker (1.3.4) unstable; urgency=low

  * dont display number of warnings because the number of warnings
    is only correct with --warning or --verbose.
  * fix previous wrong changelog email <calvin@ap-lnx-bastiank>
  * call debug function in MailUrlData.py with correct arguments
  * clarify confusing error msg in MailUrlData.py by using str()
    (Closes: #106649)
  * fix bug which caused LinkChecker not to ignore HTML comments

 -- Bastian Kleineidam <calvin@debian.org>  Mon, 30 Jul 2001 20:37:13 +0200

linkchecker (1.3.3) unstable; urgency=low

  * init_dns_resolver: forgot to import string.lower (Closes: #101044)
  * when we have a HTTP 301 redirect and the url does not end with
    a / remind the user of a potential missing / at the end of the url
  * the recovered-from-broken-PAM release

 -- Bastian Kleineidam <calvin@debian.org>  Fri, 29 Jun 2001 13:14:19 +0200

linkchecker (1.3.2) unstable; urgency=low

  * new option --pause
  * only enable threading with 2 or more threads, not with only 1 thread
  * new debug function with variable arguments
  * more than one debug level; enable them with multiple -D options
  * workaround for broken HEAD with some Apache servers by using GET
  * enable out-of-the-box CGI scripts for Debian package in
    http://localhost/doc/linkchecker/lconline/
    this of course requires an HTTP server installed on your machine
  * change logging config in the CGI scripts, the log file can be
    enabled in linkcheck/lc_cgi.py
  * updated to standards version 3.5.5 (no changes)

 -- Bastian Kleineidam <calvin@debian.org>  Sun, 10 Jun 2001 13:20:19 +0200

linkchecker (1.3.1) unstable; urgency=low

  * remove CVS files from Debian source package by using cvs-
    buildpackage

 -- Bastian Kleineidam <calvin@debian.org>  Sat,  5 May 2001 16:05:06 +0200

linkchecker (1.3.0) unstable; urgency=low

  * require and use Python >= 2.0
  * fix ignored configfile settings for loggers
  * optional filename argument for -F (patch from
    Jamie Heilman <jamie@audible.transient.net>)
  * config file option to control which fields the loggers should print
  * fixed possible inifinite loop with redirections (thanks to
    Szabolcs Szakacsits for the report)
  * resolve HTML entities in link names (closes: Bug#90644)
  * debian standards version 3.5.4.0 (no changes)
  * httpslib.py:27: use extra paranthesis around connect() argument for
    Python 2.0 compatibility (thanks to Allan Bailey for the patch)
  * additionally allow https in the CGI scripts (thanks to Allan Bailey
    for the patch)
  * fix for distutils bug: python2None interpreter is wrong
  * fix default location of global config file

 -- Bastian Kleineidam <calvin@debian.org>  Sun, 29 Apr 2001 02:09:41 +0200

linkchecker (1.2.15) unstable; urgency=low

  * remove ssl modules for main linkchecker package; make a separate 
    package linkchecker-ssl for non-US
  * adjust build-depends and depends
  * fix anchor checking
  * debian standards version 3.5.2.0
  * require python-distutils >= 1.0.1, removed old compatibility code
  * added FAQ entry for broken links
  * change email address to calvin@debian.org
  * add DNS.Error to caught exceptions
  * add all html link tags (ripped from HTML::Tagset.pm)
  * updated robotparser2.py to newest version
  * catch errors when calling UrlData.checkContent
  * added linkcheckerrc to the conffiles
  * disable threading in the lc.cgi script so the machine wont be
    hogged (closes: Bug#86788)
  * fix https support: add -lssl when compiling ssl module

 -- Bastian Kleineidam <calvin@debian.org>  Sun,  4 Mar 2001 20:55:02 +0100

linkchecker (1.2.14) unstable; urgency=low

  * fixed Python 2.0 bug: TypeError: object has read-only attributes

 -- Bastian Kleineidam <calvin@users.sourceforge.net>  Thu, 11 Jan 2001 21:29:00 +0100

linkchecker (1.2.13) unstable; urgency=low

  * linkcheck/HttpUrlData.py:
    - better redirection handling
    - really use host variable in "Host:" header
    - support response code "305 Use proxy"
  * linkcheck/robotparser2.py:
    - better redirection handling
    - cope with user-agent: lines without a preceding blank line
    - printed "Allow" when I meant "Disallow". This has been fixed.
    - two licenses: GPL and Python 2.0
  * linkcheck/__init__.py: user friendly warning for keyboard interrupts
  * debian/control: standards version 3.2.1
  * support Mozilla-specific find: links
  * print link names for:


=== debian/control ===
Source: linkchecker
Section: web
Priority: optional
Maintainer: Bastian Kleineidam <calvin@debian.org>
Build-Depends: python-dev (>= 2.1), python-dev (<< 2.2), debhelper (>= 3.0.0)
Build-Depends-Indep: gettext
Standards-Version: 3.5.6

Package: linkchecker
Architecture: all
Depends: python (>= 2.1), python (<< 2.2)
Suggests: linkchecker-ssl
Description: check HTML documents for broken links
 Features:
  o recursive checking
  o multithreaded
  o output can be colored or normal text, HTML, SQL, CSV or a sitemap
    graph in GML or XML
  o HTTP/1.1, FTP, mailto:, nntp:, news:, Gopher, Telnet and local 
    file links are supported
  o restrict link checking with regular expression filters for URLs
  o proxy support
  o give username/password for HTTP and FTP authorization
  o robots.txt exclusion protocol support 
  o i18n support
  o command line interface
  o (Fast)CGI web interface (requires HTTP server)

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.
PACKAGE=linkchecker
DOCDIR = debian/$(PACKAGE)/usr/share/doc/$(PACKAGE)

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This is the debhelper compatability version to use.
export DH_COMPAT=3

# This has to be exported to make some magic below work.
export DH_OPTIONS

configure: configure-stamp
configure-stamp:
	dh_testdir
	./setup.py config -lcrypto
	touch configure-stamp


build: configure-stamp build-stamp
build-stamp:
	dh_testdir
	rm -rf debian/linkchecker debian/linkchecker-ssl
	python setup.py build
	touch build-stamp

clean:
	dh_testdir
	rm -f build-stamp configure-stamp
	$(MAKE) clean
	dh_clean

install: build
	dh_testdir
	dh_clean -k
	dh_installdirs
	$(MAKE) locale
	python setup.py install --root=$(CURDIR)/debian/$(PACKAGE) --no-compile
	# remove man pages, we install them with dh_installman
	rm -r debian/$(PACKAGE)/usr/man
	# remove files, we install them below
	rm -r debian/$(PACKAGE)/usr/share/linkchecker/examples
	# remove any SSL related files
	rm -r debian/$(PACKAGE)/usr/lib/python2.1/site-packages/linkcheckssl
	# install additional doc files
	install -c -m 644 DNS/README $(DOCDIR)/README_DNS.txt
	install -c -m 644 test/*.py $(DOCDIR)/test
	install -c -m 644 test/html/*.html $(DOCDIR)/test/html
	install -c -m 644 test/output/test_* $(DOCDIR)/test/output
	# install CGI files
	install -c -m 644 lconline/*.html $(DOCDIR)/lconline
	install -c -m 755 lc.cgi debian/$(PACKAGE)/usr/lib/cgi-bin/lconline
	# install system wide configuration file in etc
	mv debian/$(PACKAGE)/usr/share/linkchecker/linkcheckerrc debian/$(PACKAGE)/etc


# Build architecture-independent files here.
binary-indep: build install
	dh_testdir
	dh_testroot
#	dh_installdebconf
	dh_installdocs
#	dh_installexamples
#	dh_installmenu
#	dh_installemacsen
#	dh_installpam
#	dh_installinit
#	dh_installcron
	dh_installman linkchecker.1
#	dh_installinfo
#	dh_undocumented linkchecker.1
	dh_installchangelogs 
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
#	dh_makeshlibs
	dh_installdeb
#	dh_perl
#	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

# Build architecture-dependent files here.
binary-arch: build install

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure

## linkchecker 1.12.3

=== Makefile ===
# This Makefile is only used by developers.
PYTHON := python2.3
VERSION = $(shell $(PYTHON) setup.py --version)
PACKAGE := linkchecker
NAME = $(shell $(PYTHON) setup.py --name)
PACKAGEDIR = /home/groups/l/li/$(PACKAGE)
#HTMLDIR=shell1.sourceforge.net:$(PACKAGEDIR)/htdocs
HTMLDIR=/home/calvin/public_html/linkchecker.sf.net/htdocs
#HOST=treasure.calvinsplayground.de
HOST=www.debian.org
#LCOPTS=-ocolored -Ftext -Fhtml -Fgml -Fsql -Fcsv -Fxml -R -t0 -v -s
LCOPTS=-ocolored -Ftext -Fhtml -Fgml -Fsql -Fcsv -Fxml -R -t0 -v -s -r1
TEST := test/run.sh test/regrtest.py
OFFLINETESTS = test_base test_misc test_file test_frames
ONLINETESTS = test_mail test_http test_https test_news test_ftp test_telnet
DESTDIR=/.
MD5SUMS=linkchecker-md5sums.txt

PYCHECKEROPTS := -F pycheckrc
PYCHECKERFILES := linkcheck/*.py linkcheck/parser/*.py \
                  linkcheck/DNS/*.py linkcheck/log/*.py

all:
	@echo "Read the file INSTALL to see how to build and install"

clean:
# ignore errors of this command
	-$(PYTHON) setup.py clean --all
	$(MAKE) -C po clean
	rm -f linkcheck/parser/htmlsax.so
	find . -name '*.py[co]' | xargs rm -f

distclean: clean cleandeb
# just to be sure clean also the build dir
	rm -rf dist build
	rm -f VERSION _$(PACKAGE)_configdata.py MANIFEST Packages.gz
# clean aborted dist builds and -out files
	rm -f $(PACKAGE)-out* $(PACKAGE).prof $(PACKAGE)-md5sums.txt

cleandeb:
	rm -rf debian/$(PACKAGE) debian/tmp
	rm -f debian/*.debhelper debian/{files,substvars}
	rm -f configure-stamp build-stamp

config:
	$(PYTHON) setup.py config -lcrypto

dist:	releasecheck distclean locale config
	$(PYTHON) setup.py sdist --formats=gztar bdist_rpm

# to build in the current directory (assumes python 2.3)
localbuild:
	$(MAKE) -C linkcheck/parser
	$(PYTHON) setup.py build
	cp -f build/lib.linux-i686-2.3/linkcheck/parser/htmlsax.so linkcheck/parser


# produce the .deb Debian package
deb_local: cleandeb
# standard for local use
	fakeroot debian/rules binary

deb_signed: cleandeb
# ready for upload, signed with my GPG key
	env CVSROOT=:ext:calvin@cvs.linkchecker.sourceforge.net:/cvsroot/linkchecker cvs-buildpackage -Mlinkchecker -W/home/calvin/projects/cvs-build -sgpg -pgpg -k32EC6F3E -r"fakeroot --" -I.cvsignore

files:	locale localbuild
	env http_proxy="" LANG=C $(PYTHON) $(PACKAGE) $(LCOPTS) -i$(HOST) http://$(HOST)/
	rm -f linkchecker-out.*.gz
	for f in linkchecker-out.*; do gzip --best $$f; done

VERSION:
	echo $(VERSION) > VERSION

upload:
	rm -f $(MD5SUMS)
	md5sum dist/* > $(MD5SUMS)
	for f in dist/*; do gpg --detach-sign --armor $$f; done
	ncftpput upload.sourceforge.net /incoming dist/*

homepage: files VERSION
	cp ChangeLog $(HTMLDIR)/changes.txt
	cp README $(HTMLDIR)/readme.txt
	cp linkchecker-out.*.gz $(HTMLDIR)
	cp VERSION $(HTMLDIR)/raw/
	cp $(MD5SUMS) $(HTMLDIR)/

test:
	$(TEST) $(OFFLINETESTS)

onlinetest:
	$(TEST) $(ONLINETESTS)

locale:
	$(MAKE) -C po

timeouttest:
	$(PYTHON) $(PACKAGE) -v --timeout=0 mailto:root@aol.com

tar:	distclean
	cd .. && tar cjvf linkchecker.tar.bz2 linkchecker

releasecheck:
	@if grep xxxx ChangeLog > /dev/null; then \
	  echo "Could not release: edit ChangeLog release date"; false; \
	fi

pycheck:
	-env PYTHONVER=2.3 pychecker $(PYCHECKEROPTS) $(PYCHECKERFILES)

.PHONY: all clean cleandeb distclean files upload test timeouttest locale
.PHONY: onlinetest config dist deb_local deb_signed deb_unsigned tar

=== po/Makefile ===
# we use the scripts in Tools/i18n of the Python 2.3 distribution
PYTHON := python2.3
I18NTOOLS := .
GETTEXT := $(PYTHON) $(I18NTOOLS)/pygettext.py -k i18n._
#MSGFMT := $(PYTHON) $(I18NTOOLS)/msgfmt.py
MSGFMT := msgfmt -c
MSGMERGE := msgmerge
SOURCES = $(shell find ../linkcheck -name \*.py) \
../linkchecker

LDIR=../share/locale
PACKAGE=linkcheck
LFILE=LC_MESSAGES/$(PACKAGE).mo
# defined language (add new languages here)
LANGUAGES=de fr nl
MOS=$(patsubst %, %.mo, $(LANGUAGES) )

all:	$(MOS)

win:
	if [ ! -d $(LDIR)/de/LC_MESSAGES ]; then \
	  mkdir -p $(LDIR)/de/LC_MESSAGES; \
	fi
	$(MSGFMT) -o$(LDIR)/de/$(LFILE) de.po

%.po:	$(PACKAGE).pot
	$(MSGMERGE) $@ $(PACKAGE).pot -o $@

$(PACKAGE).pot: $(SOURCES)
	$(GETTEXT) --default-domain=$(PACKAGE) --no-location $(SOURCES)

%.mo:	%.po
	if [ ! -d $(LDIR)/$*/LC_MESSAGES ]; then \
	  mkdir -p $(LDIR)/$*/LC_MESSAGES; \
	fi
	$(MSGFMT) -o$(LDIR)/$*/$(LFILE) $<

clean:
	for f in $(LANGUAGES); do rm -f $(LDIR)/$$f/$(LFILE); done

.PHONY: all clean

=== linkcheck/parser/Makefile ===
# parser needs flex >= 2.5.xx from http://lex.sf.net/
# for reentrant bison parser support!
FLEX=flex
PYVER=2.3
PYTHON=python$(PYVER)

all: htmllex.c htmlparse.c

%.o:	%.c
	gcc -g -O3 -Wall -pedantic -Wstrict-prototypes -fPIC -I. -I/usr/include/$(PYTHON) -c $< -o $@

htmlparse.h htmlparse.c:	htmlparse.y htmlsax.h
	bison htmlparse.y

htmllex.l:	htmlparse.h

htmllex.c:	htmllex.l htmlsax.h
	$(FLEX) htmllex.l

test:	testsax
	cat test.html | ./testsax

clean:
	rm -f htmlparse.c htmlparse.h htmllex.c *.o *.output

splint:
	splint -initallelements +posixlib -I/usr/include/linux -I. -I/usr/include/$(PYTHON) htmllex.c | less

## linkchecker 2.5

=== Makefile ===
# This Makefile is only used by developers.
PYVER := 2.4
PYTHON := python$(PYVER)
PACKAGE := linkchecker
NAME = $(shell $(PYTHON) setup.py --name)
VERSION = $(shell $(PYTHON) setup.py --version)
PACKAGEDIR = /home/groups/l/li/$(PACKAGE)
#HTMLDIR=shell1.sourceforge.net:$(PACKAGEDIR)/htdocs
HTMLDIR=/home/calvin/public_html/linkchecker.sf.net/htdocs
#HOST=treasure.calvinsplayground.de
HOST=www.debian.org
#LCOPTS=-Ftext -Fhtml -Fgml -Fsql -Fcsv -Fxml -v -s
LCOPTS=-Ftext -Fhtml -Fgml -Fsql -Fcsv -Fxml -v -s -r1
DESTDIR = /.
PYFILES := $(wildcard linkcheck/*.py linkcheck/logger/*.py \
	linkcheck/checker/*.py)
TESTFILES := $(wildcard linkcheck/tests/*.py linkcheck/ftests/*.py)
PYCHECKEROPTS := -F config/pycheckrc
PYLINT := env PYTHONPATH=. PYLINTRC=config/pylintrc pylint.$(PYTHON)
PYLINTOPTS := 
PYLINTBROKEN = 
PYLINTFILES = $(filter-out $(PYLINTBROKEN),$(PYFILES))

all:
	@echo "Read the file doc/install.txt to see how to build and install this package."

clean:
# ignore errors of this command
	-$(PYTHON) setup.py clean --all
	rm -f sign-stamp release-stamp
	$(MAKE) -C po clean
	rm -f linkcheck/HtmlParser/htmlsax.so
	rm -f linkcheck/HtmlParser/*.output
	find . -name '*.py[co]' | xargs rm -f

distclean: clean cleandeb
# just to be sure clean also the build dir
	rm -rf dist build
	rm -f _$(PACKAGE)_configdata.py MANIFEST Packages.gz
# clean aborted dist builds and -out files
	rm -f $(PACKAGE)-out* $(PACKAGE).prof $(PACKAGE)-md5sums.txt
	rm -rf $(PACKAGE)-$(VERSION)

cleandeb:
	rm -rf debian/$(PACKAGE) debian/tmp
	rm -f debian/*.debhelper debian/{files,substvars}
	rm -f configure-stamp build-stamp

config:
	$(PYTHON) setup.py config -lcrypto

locale:
	$(MAKE) -C po

# to build in the current directory
localbuild:
	$(MAKE) -C linkcheck/HtmlParser
	$(PYTHON) setup.py build
	cp -f build/lib.linux-i686-$(PYVER)/linkcheck/HtmlParser/htmlsax.so linkcheck/HtmlParser
	cp -f build/lib.linux-i686-$(PYVER)/linkcheck/ftpparse/_ftpparse.so linkcheck/ftpparse

# produce the .deb Debian package
deb_local: cleandeb
# standard for local use
	fakeroot debian/rules binary

deb_signed: cleandeb
# ready for upload, signed with my GPG key
	env CVSROOT=:ext:calvin@cvs.linkchecker.sourceforge.net:/cvsroot/linkchecker cvs-buildpackage -Mlinkchecker -W/home/calvin/projects/cvs-build -sgpg -pgpg -k32EC6F3E -r"fakeroot --" -I.cvsignore

files:	locale localbuild
	env http_proxy="" LANG=C $(PYTHON) $(PACKAGE) $(LCOPTS) -i$(HOST) http://$(HOST)/
	rm -f linkchecker-out.*.gz
	for f in linkchecker-out.*; do gzip --best $$f; done

release: releasecheck dist upload homepage
	mozilla -remote "OpenUrl(https://sourceforge.net/projects/linkchecker,new-tab)"
	@echo "Make SF release and press return..."
	@read
	@echo "Uploading new LinkChecker Homepage..."
	$(MAKE) -C ~/public_html/linkchecker.sf.net upload
	@echo "Register at Python Package Index..."
	$(PYTHON) setup.py register

homepage:
	$(MAKE) -C doc homepage

dist: locale config
	$(PYTHON) setup.py sdist --formats=gztar bdist_rpm

releasecheck:
	@if grep -i xxxx ChangeLog > /dev/null; then \
	  echo "Could not release: edit ChangeLog release date"; false; \
	fi

upload:
	for f in dist/*; do \
	  if [ ! -f $${f}.asc ]; then \
	    gpg --detach-sign --armor $$f; \
	  fi; \
	done
	ncftpput upload.sourceforge.net /incoming dist/*

test:
	test/run.sh test.py --resource=network --search-in=linkcheck -fupv

coverage:
	test/run.sh test.py --coverage

tar:	distclean
	cd .. && tar cjvf linkchecker.tar.bz2 linkchecker

pycheck:
	-env PYTHONPATH=. PYTHONVER=$(PYVER) pychecker $(PYCHECKEROPTS) $(PYFILES)

pylint:
	$(PYLINT) $(PYLINTOPTS) $(PYLINTFILES) $(TESTFILES)

reindent:
	$(PYTHON) config/reindent.py -r -v linkcheck

.PHONY: all clean cleandeb distclean files upload test timeouttest locale
.PHONY: config deb_local deb_signed tar releasecheck pycheck pylint reindent

=== doc/Makefile ===
RESTFILES = $(wildcard *.txt)
HTMLFILES = $(patsubst %.txt, %.html, $(RESTFILES) )
NAVFILES = $(patsubst %.txt, %.nav, $(RESTFILES) )
HTMLDIR := /home/calvin/public_html/linkchecker.sf.net

all: $(HTMLFILES)

%.html: %.txt htmlnav.py bfknav.py
	./rest2htmlnav --stylesheet-path=lc.css --time $< $@

nav: all
	python2.4 bfknav.py

homepage: nav
	cp *.html *.css *.jpg *.png $(HTMLDIR)/htdocs

clean:
	rm -f $(NAVFILES) $(HTMLFILES) *.pyc *.pyo

apidocs:
	epydoc --html -o api --name "LinkChecker source documentation" --url ../index.html ../linkcheck/

.PHONY: all clean homepage nav apidocs

=== po/Makefile ===
XGETTEXT := xgettext
MSGFMT := msgfmt
MSGMERGE := msgmerge
POSOURCES = $(shell find ../linkcheck -name \*.py) \
	../linkchecker /usr/lib/python2.4/optparse.py
LDIR = ../share/locale
PACKAGE = linkchecker
TEMPLATE = $(PACKAGE).pot
MYMAIL := calvin@users.sourceforge.net
LFILE = LC_MESSAGES/$(PACKAGE).mo
# defined language (add new languages here)
LANGUAGES = de fr nl es

mofiles:
	@for la in $(LANGUAGES); do \
	  if [ ! -d $(LDIR)/$$la/LC_MESSAGES ]; then \
	    mkdir -p $(LDIR)/$$la/LC_MESSAGES; \
	  fi; \
	  echo "Formatting language catalog $${la}:"; \
	  $(MSGFMT) -c --statistics -o $(LDIR)/$$la/$(LFILE) $$la.po; \
	done

%.po:	$(TEMPLATE)
	$(MSGMERGE) -U --suffix=.bak $@ $<

template: $(TEMPLATE)
$(TEMPLATE): $(POSOURCES)
	$(XGETTEXT) -w 80 --default-domain=$(PACKAGE) --language=Python \
	  --copyright-holder="Bastian Kleineidam <$(MYMAIL)>" \
	  --msgid-bugs-address=$(MYMAIL) -o $(TEMPLATE) \
	  --keyword=_n:1,2 $(POSOURCES)

%.mo:	%.po
	if [ ! -d $(LDIR)/$*/LC_MESSAGES ]; then \
	  mkdir -p $(LDIR)/$*/LC_MESSAGES; \
	fi
	$(MSGFMT) -c --statistics -o $(LDIR)/$*/$(LFILE) $<

clean:
	@for f in $(LANGUAGES); do rm -f $(LDIR)/$$f/$(LFILE); done
	rm -f *.mo *.bak

.PHONY: mofiles clean

## linkchecker 2.8

=== Makefile ===
--- 
+++ 
@@ -2,8 +2,8 @@
 PYVER := 2.4
 PYTHON := python$(PYVER)
 PACKAGE := linkchecker
-NAME = $(shell $(PYTHON) setup.py --name)
-VERSION = $(shell $(PYTHON) setup.py --version)
+NAME := $(shell $(PYTHON) setup.py --name)
+VERSION := $(shell $(PYTHON) setup.py --version)
 PACKAGEDIR = /home/groups/l/li/$(PACKAGE)
 #HTMLDIR=shell1.sourceforge.net:$(PACKAGEDIR)/htdocs
 HTMLDIR=/home/calvin/public_html/linkchecker.sf.net/htdocs
@@ -18,8 +18,8 @@
 PYCHECKEROPTS := -F config/pycheckrc
 PYLINT := env PYTHONPATH=. PYLINTRC=config/pylintrc pylint.$(PYTHON)
 PYLINTOPTS := 
-PYLINTBROKEN = 
-PYLINTFILES = $(filter-out $(PYLINTBROKEN),$(PYFILES))
+PYLINTIGNORE = linkcheck/httplib2.py
+PYLINTFILES = $(filter-out $(PYLINTIGNORE),$(PYFILES))
 
 all:
 	@echo "Read the file doc/install.txt to see how to build and install this package."
@@ -31,7 +31,7 @@
 	$(MAKE) -C po clean
 	rm -f linkcheck/HtmlParser/htmlsax.so
 	rm -f linkcheck/HtmlParser/*.output
-	find . -name '*.py[co]' | xargs rm -f
+	find . -name '*.py[co]' -exec rm -f {} \;
 
 distclean: clean cleandeb
 # just to be sure clean also the build dir
@@ -46,14 +46,14 @@
 	rm -f debian/*.debhelper debian/{files,substvars}
 	rm -f configure-stamp build-stamp
 
-config:
-	$(PYTHON) setup.py config -lcrypto
+MANIFEST: MANIFEST.in setup.py
+	$(PYTHON) setup.py sdist --manifest-only
 
 locale:
 	$(MAKE) -C po
 
 # to build in the current directory
-localbuild:
+localbuild: MANIFEST
 	$(MAKE) -C linkcheck/HtmlParser
 	$(PYTHON) setup.py build
 	cp -f build/lib.linux-i686-$(PYVER)/linkcheck/HtmlParser/htmlsax.so linkcheck/HtmlParser
@@ -83,9 +83,9 @@
 	$(PYTHON) setup.py register
 
 homepage:
-	$(MAKE) -C doc homepage
+	$(MAKE) -C doc/en homepage
 
-dist: locale config
+dist: locale MANIFEST
 	$(PYTHON) setup.py sdist --formats=gztar bdist_rpm
 
 releasecheck:
@@ -101,7 +101,7 @@
 	done
 	ncftpput upload.sourceforge.net /incoming dist/*
 
-test:
+test:	localbuild
 	test/run.sh test.py --resource=network --search-in=linkcheck -fupv
 
 coverage:
@@ -120,4 +120,4 @@
 	$(PYTHON) config/reindent.py -r -v linkcheck
 
 .PHONY: all clean cleandeb distclean files upload test timeouttest locale
-.PHONY: config deb_local deb_signed tar releasecheck pycheck pylint reindent
+.PHONY: deb_local deb_signed tar releasecheck pycheck pylint reindent

=== po/Makefile ===
--- 
+++ 
@@ -9,7 +9,9 @@
 MYMAIL := calvin@users.sourceforge.net
 LFILE = LC_MESSAGES/$(PACKAGE).mo
 # defined language (add new languages here)
-LANGUAGES = de fr nl es
+LANGUAGES = de fr es
+
+all: template
 
 mofiles:
 	@for la in $(LANGUAGES); do \

=== doc/en/Makefile ===
RESTFILES = $(wildcard *.txt)
HTMLFILES = $(patsubst %.txt, %.html, $(RESTFILES) )
NAVFILES = $(patsubst %.txt, %.nav, $(RESTFILES) )
HTMLDIR := /home/calvin/public_html/linkchecker.sf.net

all: $(HTMLFILES)

%.html:	%.txt ../htmlnav.py ../bfknav.py
	../rest2htmlnav --stylesheet-path=lc.css --time $< $@

nav: all
	python2.4 ../bfknav.py

homepage: nav
	cp *.html *.css *.jpg *.png $(HTMLDIR)/htdocs

=== linkcheck/HtmlParser/Makefile ===
# this parser needs flex >= 2.5.xx from http://lex.sf.net/
# for reentrant bison parser support!
FLEX = flex
PYVER = 2.3
PYTHON = python$(PYVER)

all: htmllex.c htmlparse.c

%.o:	%.c
	gcc -g -std=c99 -O3 -Wall -pedantic -Wstrict-prototypes -fPIC -I. -I/usr/include/$(PYTHON) -c $< -o $@

htmlparse.h htmlparse.c:	htmlparse.y htmlsax.h
	bison htmlparse.y

htmllex.l:	htmlparse.h

htmllex.c:	htmllex.l htmlsax.h
	$(FLEX) htmllex.l
	awk -f fixincludes.awk htmllex.c > htmllex.c.fixed; mv -f htmllex.c.fixed htmllex.c

clean:
	rm -f htmlparse.c htmlparse.h htmllex.c *.o *.so *.pyc *.pyo *.output

splint:
	splint -initallelements +posixlib -I/usr/include/linux -I. -I/usr/include/$(PYTHON) htmllex.c | less

## linkchecker 3.1

=== Makefile ===
--- 
+++ 
@@ -2,16 +2,9 @@
 PYVER := 2.4
 PYTHON := python$(PYVER)
 PACKAGE := linkchecker
-NAME := $(shell $(PYTHON) setup.py --name)
 VERSION := $(shell $(PYTHON) setup.py --version)
-PACKAGEDIR = /home/groups/l/li/$(PACKAGE)
-#HTMLDIR=shell1.sourceforge.net:$(PACKAGEDIR)/htdocs
-HTMLDIR=/home/calvin/public_html/linkchecker.sf.net/htdocs
-#HOST=treasure.calvinsplayground.de
 HOST=www.debian.org
-#LCOPTS=-Ftext -Fhtml -Fgml -Fsql -Fcsv -Fxml -v -s
-LCOPTS=-Ftext -Fhtml -Fgml -Fsql -Fcsv -Fxml -v -s -r1
-DESTDIR = /.
+LCOPTS=-Ftext -Fhtml -Fgml -Fsql -Fcsv -Fxml -Fgxml -Fdot -v -r1 -t0
 PYFILES := $(wildcard linkcheck/*.py linkcheck/logger/*.py \
 	linkcheck/checker/*.py)
 TESTFILES := $(wildcard linkcheck/tests/*.py linkcheck/ftests/*.py)
@@ -69,14 +62,13 @@
 	env CVSROOT=:ext:calvin@cvs.linkchecker.sourceforge.net:/cvsroot/linkchecker cvs-buildpackage -Mlinkchecker -W/home/calvin/projects/cvs-build -sgpg -pgpg -k32EC6F3E -r"fakeroot --" -I.cvsignore
 
 files:	locale localbuild
-	env http_proxy="" LANG=C $(PYTHON) $(PACKAGE) $(LCOPTS) -i$(HOST) http://$(HOST)/
+	test/run.sh linkchecker $(LCOPTS) http://$(HOST)/
 	rm -f linkchecker-out.*.gz
 	for f in linkchecker-out.*; do gzip --best $$f; done
 
-release: releasecheck dist upload homepage
-	mozilla -remote "OpenUrl(https://sourceforge.net/projects/linkchecker,new-tab)"
-	@echo "Make SF release and press return..."
-	@read
+release: releasecheck dist sign_distfiles homepage
+	@echo "Starting releaseforge..."
+	@releaseforge
 	@echo "Uploading new LinkChecker Homepage..."
 	$(MAKE) -C ~/public_html/linkchecker.sf.net upload
 	@echo "Register at Python Package Index..."
@@ -93,19 +85,15 @@
 	  echo "Could not release: edit ChangeLog release date"; false; \
 	fi
 
-upload:
+sign_distfiles:
 	for f in dist/*; do \
 	  if [ ! -f $${f}.asc ]; then \
 	    gpg --detach-sign --armor $$f; \
 	  fi; \
 	done
-	ncftpput upload.sourceforge.net /incoming dist/*
 
-test:	localbuild
-	test/run.sh test.py --resource=network --search-in=linkcheck -fupv
-
-coverage:
-	test/run.sh test.py --coverage
+check:	localbuild
+	test/test.sh
 
 tar:	distclean
 	cd .. && tar cjvf linkchecker.tar.bz2 linkchecker
@@ -119,5 +107,6 @@
 reindent:
 	$(PYTHON) config/reindent.py -r -v linkcheck
 
-.PHONY: all clean cleandeb distclean files upload test timeouttest locale
+.PHONY: all clean cleandeb dist distclean homepage files upload locale
 .PHONY: deb_local deb_signed tar releasecheck pycheck pylint reindent
+.PHONY: sign_distfiles

=== gui/Makefile ===
PYVER := 2.4
PYTHON := python$(PYVER)
OPTS := --copyright="Copyright (C) 2005 Bastian Kleineidam" \
	--license=py_gpl_head.txt  --threads

glade:
	$(PYTHON) simple-glade-codegen.py $(OPTS) glinkchecker.glade

=== doc/en/Makefile ===
--- 
+++ 
@@ -12,5 +12,5 @@
 	python2.4 ../bfknav.py
 
 homepage: nav
-	cp *.html *.css *.jpg *.png $(HTMLDIR)/htdocs
+	cp *.html *.css *.jpg *.png *.ico $(HTMLDIR)/htdocs

## linkchecker 3.3

=== Makefile ===
--- 
+++ 
@@ -13,10 +13,13 @@
 PYLINTOPTS := 
 PYLINTIGNORE = linkcheck/httplib2.py
 PYLINTFILES = $(filter-out $(PYLINTIGNORE),$(PYFILES))
+PYFLAKES:=pyflakes
 
+.PHONY: all
 all:
 	@echo "Read the file doc/install.txt to see how to build and install this package."
 
+.PHONY: clean
 clean:
 # ignore errors of this command
 	-$(PYTHON) setup.py clean --all
@@ -26,14 +29,16 @@
 	rm -f linkcheck/HtmlParser/*.output
 	find . -name '*.py[co]' -exec rm -f {} \;
 
+.PHONY: distclean
 distclean: clean cleandeb
 # just to be sure clean also the build dir
 	rm -rf dist build
 	rm -f _$(PACKAGE)_configdata.py MANIFEST Packages.gz
 # clean aborted dist builds and -out files
-	rm -f $(PACKAGE)-out* $(PACKAGE).prof $(PACKAGE)-md5sums.txt
+	rm -f $(PACKAGE)-out* $(PACKAGE).prof
 	rm -rf $(PACKAGE)-$(VERSION)
 
+.PHONY: cleandeb
 cleandeb:
 	rm -rf debian/$(PACKAGE) debian/tmp
 	rm -f debian/*.debhelper debian/{files,substvars}
@@ -42,10 +47,12 @@
 MANIFEST: MANIFEST.in setup.py
 	$(PYTHON) setup.py sdist --manifest-only
 
+.PHONY: locale
 locale:
 	$(MAKE) -C po
 
 # to build in the current directory
+.PHONY: localbuild
 localbuild: MANIFEST
 	$(MAKE) -C linkcheck/HtmlParser
 	$(PYTHON) setup.py build
@@ -53,20 +60,24 @@
 	cp -f build/lib.linux-i686-$(PYVER)/linkcheck/ftpparse/_ftpparse.so linkcheck/ftpparse
 
 # produce the .deb Debian package
+.PHONY: deb_local
 deb_local: cleandeb
 # standard for local use
 	fakeroot debian/rules binary
 
+.PHONY: deb_signed
 deb_signed: cleandeb
 # ready for upload, signed with my GPG key
 	env CVSROOT=:ext:calvin@cvs.linkchecker.sourceforge.net:/cvsroot/linkchecker cvs-buildpackage -Mlinkchecker -W/home/calvin/projects/cvs-build -sgpg -pgpg -k32EC6F3E -r"fakeroot --" -I.cvsignore
 
+.PHONY: files
 files:	locale localbuild
-	test/run.sh linkchecker $(LCOPTS) http://$(HOST)/
+	-test/run.sh linkchecker $(LCOPTS) http://$(HOST)/
 	rm -f linkchecker-out.*.gz
 	for f in linkchecker-out.*; do gzip --best $$f; done
 
-release: releasecheck dist sign_distfiles homepage
+.PHONY: release
+release: releasecheck distclean dist sign_distfiles homepage
 	@echo "Starting releaseforge..."
 	@releaseforge
 	@echo "Uploading new LinkChecker Homepage..."
@@ -74,17 +85,21 @@
 	@echo "Register at Python Package Index..."
 	$(PYTHON) setup.py register
 
+.PHONY: homepage
 homepage:
 	$(MAKE) -C doc/en homepage
 
+.PHONY: dist
 dist: locale MANIFEST
 	$(PYTHON) setup.py sdist --formats=gztar bdist_rpm
 
+.PHONY: releasecheck
 releasecheck:
-	@if grep -i xxxx ChangeLog > /dev/null; then \
+	@if egrep -i "xx\.|xxxx|\.xx" ChangeLog > /dev/null; then \
 	  echo "Could not release: edit ChangeLog release date"; false; \
 	fi
 
+.PHONY: sign_distfiles
 sign_distfiles:
 	for f in dist/*; do \
 	  if [ ! -f $${f}.asc ]; then \
@@ -92,21 +107,25 @@
 	  fi; \
 	done
 
+.PHONY: check
 check:	localbuild
 	test/test.sh
 
-tar:	distclean
-	cd .. && tar cjvf linkchecker.tar.bz2 linkchecker
-
+.PHONY: pycheck
 pycheck:
 	-env PYTHONPATH=. PYTHONVER=$(PYVER) pychecker $(PYCHECKEROPTS) $(PYFILES)
 
+.PHONY: pylint
 pylint:
 	$(PYLINT) $(PYLINTOPTS) $(PYLINTFILES) $(TESTFILES)
 
+.PHONY: pyflakes
+pyflakes:
+	$(PYFLAKES) *.py test linkcheck | \
+          grep -v "redefinition of unused 'linkcheck'" | \
+          grep -v "undefined name '_'" | \
+	  grep -v "undefined name '_n'"
+
+.PHONY: reindent
 reindent:
 	$(PYTHON) config/reindent.py -r -v linkcheck
-
-.PHONY: all clean cleandeb dist distclean homepage files upload locale
-.PHONY: deb_local deb_signed tar releasecheck pycheck pylint reindent
-.PHONY: sign_distfiles

=== doc/en/Makefile ===
--- 
+++ 
@@ -4,6 +4,9 @@
 HTMLDIR := /home/calvin/public_html/linkchecker.sf.net
 
 all: $(HTMLFILES)
+
+clean:
+	rm -f $(HTMLFILES) $(NAVFILES)
 
 %.html:	%.txt ../htmlnav.py ../bfknav.py
 	../rest2htmlnav --stylesheet-path=lc.css --time $< $@

=== linkcheck/HtmlParser/Makefile ===
--- 
+++ 
@@ -1,13 +1,17 @@
 # this parser needs flex >= 2.5.xx from http://lex.sf.net/
 # for reentrant bison parser support!
 FLEX = flex
-PYVER = 2.3
+PYVER = 2.4
 PYTHON = python$(PYVER)
+SPARSE=sparse
 
 all: htmllex.c htmlparse.c
 
 %.o:	%.c
 	gcc -g -std=c99 -O3 -Wall -pedantic -Wstrict-prototypes -fPIC -I. -I/usr/include/$(PYTHON) -c $< -o $@
+
+sparse:
+	$(SPARSE) -D__STDC__ -I. -I/usr/include/$(PYTHON) s_util.h s_util.c htmlsax.h htmlparse.h htmlparse.c htmllex.c
 
 htmlparse.h htmlparse.c:	htmlparse.y htmlsax.h
 	bison htmlparse.y

## linkchecker 4.1

=== Makefile ===
# This Makefile is only used by developers.
PYVER := 2.4
PYTHON := python$(PYVER)
VERSION := $(shell $(PYTHON) setup.py --version)
HOST=www.debian.org
LCOPTS=-Ftext -Fhtml -Fgml -Fsql -Fcsv -Fxml -Fgxml -Fdot -v -r1 -C
# all Python files in the source
PYFILES = $(wildcard *.py) linkchecker linkcheck tests
PYLINT := env PYTHONPATH=. PYLINTRC=config/pylintrc $(PYTHON) /usr/bin/pylint
PYLINTOPTS := --disable-msg-cat=C,R,W
PYFLAKES:=pyflakes
PYTHONSVN := /home/calvin/src/python-svn
# build dir for svn-buildpackage
SVNBUILD:=/home/calvin/src/build-area
DEB_ORIG_TARGET:=$(SVNBUILD)/linkchecker_$(VERSION).orig.tar.gz


.PHONY: all
all:
	@echo "Read the file doc/install.txt to see how to build and install this package."

.PHONY: clean
clean:
# ignore errors of this command
	-$(PYTHON) setup.py clean --all
	rm -f sign-stamp release-stamp
	$(MAKE) -C po clean
	rm -f linkcheck/HtmlParser/htmlsax.so
	rm -f linkcheck/HtmlParser/*.output
	rm -f linkcheck/ftpparse/_ftpparse.so
	find . -name '*.py[co]' -exec rm -f {} \;

.PHONY: distclean
distclean: clean cleandeb
# just to be sure clean also the build dir
	rm -rf dist build
	rm -f _linkchecker_configdata.py MANIFEST Packages.gz
# clean aborted dist builds and -out files
	rm -f linkchecker-out* linkchecker.prof
	rm -rf linkchecker-$(VERSION)
	rm -rf coverage dist-stamp

.PHONY: cleandeb
cleandeb:
	rm -rf debian/linkchecker debian/tmp
	rm -f debian/*.debhelper debian/{files,substvars}
	rm -f configure-stamp build-stamp

MANIFEST: MANIFEST.in setup.py
	$(MAKE) -C doc/en all nav
	$(PYTHON) setup.py sdist --manifest-only

.PHONY: locale
locale:
	$(MAKE) -C po

# to build in the current directory
.PHONY: localbuild
localbuild: MANIFEST
	$(MAKE) -C linkcheck/HtmlParser
	$(PYTHON) setup.py build
	cp -f build/lib.linux-i686-$(PYVER)/linkcheck/HtmlParser/htmlsax.so linkcheck/HtmlParser
	cp -f build/lib.linux-i686-$(PYVER)/linkcheck/ftpparse/_ftpparse.so linkcheck/ftpparse

.PHONY: deb_orig
deb_orig:
	if [ ! -e $(DEB_ORIG_TARGET) ]; then \
	  $(MAKE) dist-stamp && \
	  cp dist/linkchecker-$(VERSION).tar.gz $(DEB_ORIG_TARGET); \
	fi

# ready for upload, signed with my GPG key
.PHONY: deb_signed
deb_signed: cleandeb
	(env -u LANG svn-buildpackage --svn-dont-clean --svn-verbose --svn-ignore \
	  --svn-prebuild="$(MAKE) deb_orig" --svn-lintian --svn-linda \
	  -sgpg -pgpg -k$(GPGKEY) -r"fakeroot --" 2>&1) | \
	tee $(SVNBUILD)/linkchecker-$(VERSION).build

.PHONY: files
files:	locale localbuild
	-scripts/run.sh linkchecker $(LCOPTS) http://$(HOST)/
	rm -f linkchecker-out.*.gz
	for f in linkchecker-out.*; do gzip --best $$f; done

.PHONY: upload
upload:
	@echo "Starting releaseforge..."
	@releaseforge
#	ncftpput upload.sourceforge.net /incoming dist/*
#	mozilla -remote "openUrl(https://sourceforge.net/projects/linkchecker, new-tab)"
#	@echo "Make SF release and press return..."
#	@read

.PHONY: release
release: releasecheck distclean dist-stamp sign_distfiles homepage upload
	@echo "Uploading new LinkChecker Homepage..."
	$(MAKE) -C ~/public_html/linkchecker.sf.net upload
	@echo "Register at Python Package Index..."
	$(PYTHON) setup.py register

.PHONY: homepage
homepage:
	$(MAKE) -C doc/en homepage

.PHONY: dist
dist: locale MANIFEST
	$(PYTHON) setup.py sdist --formats=gztar bdist_rpm

dist-stamp:
	$(MAKE) dist
	touch $@

.PHONY: syntaxcheck
syntaxcheck:
	py-verify

.PHONY: releasecheck
releasecheck: syntaxcheck
	@if egrep -i "xx\.|xxxx|\.xx" ChangeLog > /dev/null; then \
	  echo "Could not release: edit ChangeLog release date"; false; \
	fi

.PHONY: sign_distfiles
sign_distfiles:
	for f in dist/*; do \
	  if [ ! -f $${f}.asc ]; then \
	    gpg --detach-sign --armor $$f; \
	  fi; \
	done

.PHONY: test
test:	localbuild
	scripts/test.sh

.PHONY: pylint
pylint:
	$(PYLINT) $(PYLINTOPTS) $(PYFILES) | \
	  grep -v "Undefined variable '_'" | \
	  uniq

.PHONY: pyflakes
pyflakes:
	$(PYFLAKES) $(PYFILES) | \
          grep -v "redefinition of unused 'linkcheck'" | \
          grep -v "undefined name '_'" | \
	  grep -v "undefined name '_n'"

.PHONY: reindent
reindent:
	$(PYTHON) config/reindent.py -r -v linkcheck

# Compare custom Python files with the original ones from subversion.
.PHONY: diff
diff:
	@for f in gzip robotparser httplib; do \
	  echo "Comparing $${f}.py"; \
	  diff -u linkcheck/$${f}2.py $(PYTHONSVN)/Lib/$${f}.py | less; \
	done

# various python check scripts
.PHONY: various
various:
	py-check-append $(PYFILES)
	py-clean-future -r $(PYFILES)
	py-find-nocoding $(PYFILES)

## linkchecker 4.5

=== Makefile ===
--- 
+++ 
@@ -6,9 +6,7 @@
 LCOPTS=-Ftext -Fhtml -Fgml -Fsql -Fcsv -Fxml -Fgxml -Fdot -v -r1 -C
 # all Python files in the source
 PYFILES = $(wildcard *.py) linkchecker linkcheck tests
-PYLINT := env PYTHONPATH=. PYLINTRC=config/pylintrc $(PYTHON) /usr/bin/pylint
-PYLINTOPTS := --disable-msg-cat=C,R,W
-PYFLAKES:=pyflakes
+PYFLAKES:=python$(PYVER) /usr/bin/pyflakes
 PYTHONSVN := /home/calvin/src/python-svn
 # build dir for svn-buildpackage
 SVNBUILD:=/home/calvin/src/build-area
@@ -25,6 +23,8 @@
 	-$(PYTHON) setup.py clean --all
 	rm -f sign-stamp release-stamp
 	$(MAKE) -C po clean
+	$(MAKE) -C doc clean
+	$(MAKE) -C doc/en clean
 	rm -f linkcheck/HtmlParser/htmlsax.so
 	rm -f linkcheck/HtmlParser/*.output
 	rm -f linkcheck/ftpparse/_ftpparse.so
@@ -38,7 +38,7 @@
 # clean aborted dist builds and -out files
 	rm -f linkchecker-out* linkchecker.prof
 	rm -rf linkchecker-$(VERSION)
-	rm -rf coverage dist-stamp
+	rm -rf coverage dist-stamp python-build-stamp*
 
 .PHONY: cleandeb
 cleandeb:
@@ -93,7 +93,7 @@
 #	@read
 
 .PHONY: release
-release: releasecheck distclean dist-stamp sign_distfiles homepage upload
+release: distclean releasecheck dist-stamp sign_distfiles homepage upload
 	@echo "Uploading new LinkChecker Homepage..."
 	$(MAKE) -C ~/public_html/linkchecker.sf.net upload
 	@echo "Register at Python Package Index..."
@@ -120,6 +120,7 @@
 	@if egrep -i "xx\.|xxxx|\.xx" ChangeLog > /dev/null; then \
 	  echo "Could not release: edit ChangeLog release date"; false; \
 	fi
+	$(MAKE) -C doc/en test
 
 .PHONY: sign_distfiles
 sign_distfiles:
@@ -132,12 +133,6 @@
 .PHONY: test
 test:	localbuild
 	scripts/test.sh
-
-.PHONY: pylint
-pylint:
-	$(PYLINT) $(PYLINTOPTS) $(PYFILES) | \
-	  grep -v "Undefined variable '_'" | \
-	  uniq
 
 .PHONY: pyflakes
 pyflakes:

=== po/Makefile ===
--- 
+++ 
@@ -11,7 +11,7 @@
 # defined language (add new languages here)
 LANGUAGES = de fr es
 
-all: template
+all:
 
 mofiles:
 	@for la in $(LANGUAGES); do \

=== doc/en/Makefile ===
--- 
+++ 
@@ -5,15 +5,21 @@
 
 all: $(HTMLFILES)
 
+.PHONY: clean
 clean:
 	rm -f $(HTMLFILES) $(NAVFILES)
 
 %.html:	%.txt ../htmlnav.py ../bfknav.py
 	../rest2htmlnav --stylesheet-path=lc.css --time $< $@
 
+.PHONY: nav
 nav: all
 	python2.4 ../bfknav.py
 
+.PHONY: homepage
 homepage: nav
 	cp *.html *.css *.jpg *.png *.ico $(HTMLDIR)/htdocs
 
+.PHONY: test
+test:	all
+	xmllint --valid --noout *.html

=== linkcheck/HtmlParser/Makefile ===
# this parser needs flex >= 2.5.xx from http://lex.sf.net/
# for reentrant bison parser support!
FLEX = flex
PYVER = 2.4
PYTHON = python$(PYVER)

all: htmllex.c htmlparse.c

%.o:	%.c
	gcc -g -std=c99 -O3 -Wall -pedantic -Wstrict-prototypes -fPIC -I. -I/usr/include/$(PYTHON) -c $< -o $@

htmlparse.h htmlparse.c:	htmlparse.y htmlsax.h
	bison htmlparse.y

htmllex.l:	htmlparse.h

htmllex.c:	htmllex.l htmlsax.h
	$(FLEX) htmllex.l
	awk -f fixincludes.awk htmllex.c > htmllex.c.fixed; mv -f htmllex.c.fixed htmllex.c

clean:
	rm -f htmlparse.c htmlparse.h htmllex.c *.o *.so *.pyc *.pyo *.output

## linkchecker 4.6

=== Makefile ===
--- 
+++ 
@@ -33,7 +33,7 @@
 .PHONY: distclean
 distclean: clean cleandeb
 # just to be sure clean also the build dir
-	rm -rf dist build
+	rm -rf build
 	rm -f _linkchecker_configdata.py MANIFEST Packages.gz
 # clean aborted dist builds and -out files
 	rm -f linkchecker-out* linkchecker.prof

=== doc/en/Makefile ===
--- 
+++ 
@@ -9,7 +9,7 @@
 clean:
 	rm -f $(HTMLFILES) $(NAVFILES)
 
-%.html:	%.txt ../htmlnav.py ../bfknav.py
+%.html:	%.txt ../htmlnav.py ../bfknav.py lc.css
 	../rest2htmlnav --stylesheet-path=lc.css --time $< $@
 
 .PHONY: nav

## linkchecker 4.7

=== Makefile ===
--- 
+++ 
@@ -103,8 +103,13 @@
 homepage:
 	$(MAKE) -C doc/en homepage
 
+.PHONY: chmod
+chmod:
+	-chmod -R a+rX,u+w,go-w -- *
+	find . -type d -exec chmod 755 {} \;
+
 .PHONY: dist
-dist: locale MANIFEST
+dist: locale MANIFEST chmod
 	$(PYTHON) setup.py sdist --formats=gztar bdist_rpm
 
 dist-stamp:

=== linkcheck/HtmlParser/Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
 # this parser needs flex >= 2.5.xx from http://lex.sf.net/
 # for reentrant bison parser support!
 FLEX = flex
-PYVER = 2.4
+PYVER = 2.5
 PYTHON = python$(PYVER)
 
 all: htmllex.c htmlparse.c

## linkchecker 4.8

=== Makefile ===
--- 
+++ 
@@ -1,16 +1,13 @@
 # This Makefile is only used by developers.
-PYVER := 2.4
-PYTHON := python$(PYVER)
-VERSION := $(shell $(PYTHON) setup.py --version)
+PYVER=2.4
+PYTHON=python$(PYVER)
+VERSION=$(shell $(PYTHON) setup.py --version)
 HOST=www.debian.org
 LCOPTS=-Ftext -Fhtml -Fgml -Fsql -Fcsv -Fxml -Fgxml -Fdot -v -r1 -C
-# all Python files in the source
-PYFILES = $(wildcard *.py) linkchecker linkcheck tests
-PYFLAKES:=python$(PYVER) /usr/bin/pyflakes
-PYTHONSVN := /home/calvin/src/python-svn
+PYTHONSVN=/home/calvin/src/python-svn
 # build dir for svn-buildpackage
-SVNBUILD:=/home/calvin/src/build-area
-DEB_ORIG_TARGET:=$(SVNBUILD)/linkchecker_$(VERSION).orig.tar.gz
+SVNBUILD=/home/calvin/src/build-area
+DEB_ORIG_TARGET=$(SVNBUILD)/linkchecker_$(VERSION).orig.tar.gz
 
 
 .PHONY: all
@@ -74,7 +71,7 @@
 deb_signed: cleandeb
 	(env -u LANG svn-buildpackage --svn-dont-clean --svn-verbose --svn-ignore \
 	  --svn-prebuild="$(MAKE) deb_orig" --svn-lintian --svn-linda \
-	  -sgpg -pgpg -k$(GPGKEY) -r"fakeroot --" 2>&1) | \
+	  -sgpg -pgpg -k$(GPGKEY) -rfakeroot 2>&1) | \
 	tee $(SVNBUILD)/linkchecker-$(VERSION).build
 
 .PHONY: files
@@ -112,16 +109,22 @@
 dist: locale MANIFEST chmod
 	$(PYTHON) setup.py sdist --formats=gztar bdist_rpm
 
-dist-stamp:
+dist-stamp: changelog
 	$(MAKE) dist
 	touch $@
 
-.PHONY: syntaxcheck
-syntaxcheck:
+# The check programs used here are mostly local scripts on my private system.
+# So for other developers there is no need to execute this target.
+.PHONY: check
+check:
 	py-verify
+	py-find-nocoding
+	check-nosvneolstyle
+	check-pofiles
+	py24-tabnanny
 
 .PHONY: releasecheck
-releasecheck: syntaxcheck
+releasecheck: check
 	@if egrep -i "xx\.|xxxx|\.xx" ChangeLog > /dev/null; then \
 	  echo "Could not release: edit ChangeLog release date"; false; \
 	fi
@@ -141,7 +144,7 @@
 
 .PHONY: pyflakes
 pyflakes:
-	$(PYFLAKES) $(PYFILES) | \
+	pyflakes | \
           grep -v "redefinition of unused 'linkcheck'" | \
           grep -v "undefined name '_'" | \
 	  grep -v "undefined name '_n'"
@@ -158,9 +161,6 @@
 	  diff -u linkcheck/$${f}2.py $(PYTHONSVN)/Lib/$${f}.py | less; \
 	done
 
-# various python check scripts
-.PHONY: various
-various:
-	py-check-append $(PYFILES)
-	py-clean-future -r $(PYFILES)
-	py-find-nocoding $(PYFILES)
+.PHONY: changelog
+changelog:
+	sftrack_changelog linkchecker calvin@users.sourceforge.net ChangeLog

=== doc/Makefile ===
po4a:
	po4a --localized-charset=ISO-8859-15 po4a.conf

apidocs:
	epydoc --html -o api --name "LinkChecker source documentation" --url ../index.html ../linkcheck/

clean:
	rm -f *.pyc *.pyo *~

.PHONY: apidocs po4a clean

=== po/Makefile ===
--- 
+++ 
@@ -2,7 +2,7 @@
 MSGFMT := msgfmt
 MSGMERGE := msgmerge
 POSOURCES = $(shell find ../linkcheck -name \*.py) \
-	../linkchecker /usr/lib/python2.4/optparse.py
+	../linkchecker /usr/lib/python2.5/optparse.py
 LDIR = ../share/locale
 PACKAGE = linkchecker
 TEMPLATE = $(PACKAGE).pot

=== doc/en/Makefile ===
--- 
+++ 
@@ -14,7 +14,7 @@
 
 .PHONY: nav
 nav: all
-	python2.4 ../bfknav.py
+	python ../bfknav.py
 
 .PHONY: homepage
 homepage: nav
